class Thread :
  atomic<Lock *> Grant = null 

class Lock :
  atomic<Thread *> Tail = null 

def %\underline{Lock}% (Lock * L) :
  assert Self$\rightarrow$Grant $==$ null        
  ## Enqueue self at tail of implicit queue
  auto pred = swap (&L$\rightarrow$Tail, Self) 
  if pred $\neq$ null :
     ## Contention : must wait
     while pred$\rightarrow$Grant $\neq$ L : Pause
     pred$\rightarrow$Grant = null
  assert L$\rightarrow$Tail $\neq$ null
  
def %\underline{Unlock}% (Lock * L) :
  assert Self$\rightarrow$Grant $==$ null
  auto v = cas (&L$\rightarrow$Tail, Self, null)
  assert v $\neq$ null
  if v $\neq$ Self :
     ## one or more waiters exist -- convey ownership to successor
     Self$\rightarrow$Grant = L 
     while Self$\rightarrow$Grant $\neq$ null : Pause

