class Thread :
  atomic<Lock *> Grant = null 

class Lock :
  atomic<Thread *> Tail = null 

def %\underline{Lock}% (Lock * L) :
  assert Self$\rightarrow$Grant $==$ null
  auto pred = swap (&L$\rightarrow$Tail, Self) 
  if pred $\neq$ null :
     while cas(&pred$\rightarrow$Grant, L, null) $\neq$ L : Pause
  
def %\underline{Unlock}% (Lock * L) :  
  assert Self$\rightarrow$Grant $==$ null
  auto v = cas (&L$\rightarrow$Tail, Self, null)
  if v $\neq$ Self :
    Self$\rightarrow$Grant = L 
    while FetchAdd(&Self$\rightarrow$Grant, 0) $\neq$ null : Pause

