class Thread :
  atomic<Lock *> Grant = null 

class Lock :
  atomic<Thread *> Tail = null 

def %\underline{Lock}% (Lock * L) :
  auto pred = swap (&L$\rightarrow$Tail, Self) 
  if pred $\neq$ null :
     ## Note that we do use the value returned by the following cas() 
     cas (&pred$\rightarrow$Grant, 0, L|1) ; 
     while cas(&pred$\rightarrow$Grant, L, null) $\neq$ L : Pause
  
def %\underline{Unlock}% (Lock * L) :  
  if Self$\rightarrow$Grant $==$ (L|1) :
     PassLock: 
     Self$\rightarrow$Grant = L 
     while FetchAdd(&Self$\rightarrow$Grant, 0) $==$ L : Pause
     return
  auto v = cas (&L$\rightarrow$Tail, Self, null)
  assert v $\neq$ null 
  if v $\neq$ Self : goto PassLock

