class Thread :
  atomic<Lock *> Grant = null 

class Lock :
  atomic<Thread *> Tail = null 

def %\underline{Lock}% (Lock * L) :
  while Self$\rightarrow$Grant $==$ L : Pause
  auto pred = swap (&L$\rightarrow$Tail, Self) 
  if pred $\neq$ null :
     while pred$\rightarrow$Grant $\neq$ L : Pause
     pred$\rightarrow$Grant = null
  assert L$\rightarrow$Tail $\neq$ null
  
def %\underline{Unlock}% (Lock * L) :  
  auto v = cas (&L$\rightarrow$Tail, Self, null)
  assert v $\neq$ null
  if v $\neq$ Self :
     while Self$\rightarrow$Grant $\neq$ null : Pause
     Self$\rightarrow$Grant = L 

