class Thread :
  atomic<Lock *> Grant = null 

class Lock :
  atomic<Thread *> Tail = null 

def %\underline{Lock}% (Lock * L) :
  assert Self$\rightarrow$Grant $==$ null
  ## constant-time arrival "doorway" step
  auto pred = swap (&L$\rightarrow$Tail, Self) 
  if pred $\neq$ null :
     ## waiting phase 
     while cas(&pred$\rightarrow$Grant, L, null) $\neq$ L : Pause
  
def %\underline{Unlock}% (Lock * L) :  
  assert Self$\rightarrow$Grant $==$ null
  if L$\rightarrow$Tail $\neq$ Self : 
     PassLock: 
     Self$\rightarrow$Grant = L 
     while FetchAdd(&Self$\rightarrow$Grant, 0) $\neq$ null : Pause
     return
  auto v = cas (&L$\rightarrow$Tail, Self, null)
  assert v $\neq$ null 
  if v $\neq$ Self : goto PassLock

